import path from "node:path";
export function getModulePath(file, transformerOptions) {
    const pathWithoutExtension = path.join(file.path.replace(/\.[^/.]+$/, ""));
    const ext = path.extname(file.path);
    if (transformerOptions.esm) {
        switch (ext) {
            case ".ts":
                return `${pathWithoutExtension}.js`;
            case ".tsx":
                return `${pathWithoutExtension}.jsx`;
            default:
                return pathWithoutExtension + ext;
        }
    }
    return pathWithoutExtension;
}
